#ifndef plugin_contactlist_defsH
#define plugin_contactlist_defsH

#include <windows.h>

#include "plugin_struct.h"
#include "plugin_skin.h"
#include "cl_struct.h"

typedef struct {

 int structSize;		        //wielko strutkury w bajtach
 char *ID;                              //ID ikonki

 int StatesCount;                       //ilo stanw danej ikonki
 TlenSingleImageDef *SingleIcons;       //stany ikonki

 int IconKind;                          //rodzaj ikonki
 int Flags;                             //flagi
 int CurrentState;                      //obecny stan ikonki

 char *IconHint;                        //hint nad ikonk jeli jest NULL, to wtedy zwyky hint z danego itemu

 TLENFUNCTION CallBackFunc;             //funkcja callback do powiadamiania o rnych zdarzeniach ikonki
 void *OwnerData;                       //parametr uytkonika

 RECT DestRect;                         //updatowane przez list kontaktw - pozycja danej ikonki

} ContactListIconDef;

#define CONTACTLIST_ICONKIND_PRETEXT        1
#define CONTACTLIST_ICONKIND_POSTTEXT       2

#define CONTACTLIST_ICONFLAG_ISMOUSEOVER         0x00001000

#define CONTACTLIST_ICONFLAG_CHANGE_CURRENTSTATE 0x00010000
#define CONTACTLIST_ICONFLAG_CHANGE_ICONKIND     0x00020000
#define CONTACTLIST_ICONFLAG_CHANGE_SINGLEICONS  0x00040000
#define CONTACTLIST_ICONFLAG_CHANGE_FLAGS        0x00080000
#define CONTACTLIST_ICONFLAG_CHANGE_CALLBACK     0x00100000
#define CONTACTLIST_ICONFLAG_CHANGE_OWNERDATA    0x00200000
#define CONTACTLIST_ICONFLAG_CHANGE_HINT         0x00400000

typedef struct {

 int structSize;		        //wielko strutkury w bajtach

 int ItemHandle;                        //wypeniane po dodaniu kontaktu - przyznawany jest
                                        //unikalny handle, przy pomocy ktrego odwoujemy sie do danej pozycji

 int SectionHandle;                     //jeli dodajemy grup, lub pozycj, musimy ustali w jakiej sekcji
 int GroupHandle;                       //jeli dodajemy pozycj - musimy ustali w jakiej grupie ma si znajdowa
 int PreviousItemHandle;                //uchwyt sekcji, grupy, pozycji po ktrej naley wstawi dany kontakt
                                        //jeli damy tu -1, to wstawi na pocztek, jeli 0 to na koniec

 int ItemKind;                          //rodzaj pozycji (sekcja, grupa, element)
 int ItemSubKind;                       //podrodzaj pozycji (kontakt, statyczny pasek, inny)

 int Flags1;                            //flagi
 int Flags2;
 int Flags3;
 int ChangeFlags;                       //flagi do zmiany waciwoci elementu

 char *MainText;                        //gwny tekst - np. nazwa kontaktu, etc.
 char *SecondaryText;                   //tekst poboczny - np. ilo osb w danej grupie
 char *LowerText;                       //tekst poniej gwnego - przy kontaktach - wywietlaniu stanu opisowego

 char *ItemHint;                        //tekst pomocy po najechaniu myszk na pozycj i odczekaniu chwili

 ContactDef ContactInfo;                //informacje o kontakcie skojarzonym z dan pozycj

 char *MenuID;                          //ID menu przypisanego do danej pozycji

 int IconsCount;                        //ilo ikonek
 ContactListIconDef *Icons;             //wskanik do ikonki/tablicy z ikonkami

 TLENFUNCTION CallBackFunc;             //funkcja callback do notyfikacji rnych
 TLENFUNCTION CallBackCompareFunc;      //funkcja callback do sortowania dzieci danej pozycji
                                        //zwraca -1, 0, 1  (<, =, >)

 void *OwnerData;                       //parametr uytkownika
 void *Reserved;
 
 // wersja z metagrupami
 int MetaGroupHandle; // uchwyt do grupy zlaczonych kontaktow, jesli ItemSubKind
 // jest typu METAGROUP
 char MetaGroupIconMap[7]; // tablica mapujaca stan ikonki kontaktu na stan ikonki
 // metakontaktu, np jesli ikonka kontaktu ma stan 2 i to odpowiada stanowi
 // ikonki metakontaktu 3, to w 3-cim elemencie tej tablicy jest wartosc 2
 char *ItemNewHint; // do nowych hintow, ktore pokazuja ikonke i opis kontaktu

 void *avatar;			// wskaznik do obiektu awatara

} ContactListItemDef;

#define CONTACTLIST_ITEMPOS_LAST    0
#define CONTACTLIST_ITEMPOS_FIRST  -1

#define CONTACTLIST_ITEMKIND_SECTION    1
#define CONTACTLIST_ITEMKIND_GROUP      2
#define CONTACTLIST_ITEMKIND_ELEMENT    3

#define CONTACTLIST_ITEMSUBKIND_STATICBAR  1
#define CONTACTLIST_ITEMSUBKIND_CONTACT    2
#define CONTACTLIST_ITEMSUBKIND_OTHER      3
#define CONTACTLIST_ITEMSUBKIND_METAGROUP  4

//(niektre flagi nie s jeszcze zaimplementowane)
#define CONTACTLIST_ITEMFLAG1_EXPANDED           0x00000001 //czy rozwinity (grupa, sekcja)
#define CONTACTLIST_ITEMFLAG1_NOGROUPICON        0x00000002 //czy pokazuje znaczek rozwinicia
#define CONTACTLIST_ITEMFLAG1_EXPANDABLE         0x00000004 //czy da si zwin
#define CONTACTLIST_ITEMFLAG1_UNSELECTABLE       0x00000008 //czy da si zaznacza
#define CONTACTLIST_ITEMFLAG1_SELECTCALLBACK     0x00000010 //czy przed decyzj o zaznaczeniu powinien wywoa callback z zapytaniem
#define CONTACTLIST_ITEMFLAG1_AUTOEXPAND         0x00000020 //po najechaniu myszk na sekcj czy grup automatycznie si rozwija jeli bya zwinita, zaraz po zjechaniu zwija si z powrotem
#define CONTACTLIST_ITEMFLAG1_DBLCLKEXPAND       0x00000040 //po podwjnym kliku si zwija-rozwija, nie po jednym
#define CONTACTLIST_ITEMFLAG1_OWNERDRAWN         0x00000080 //element rysowany samodzielnie w funkcji callback
#define CONTACTLIST_ITEMFLAG1_HIDDEN             0x00000100 //czy dany element ma by ukryty
#define CONTACTLIST_ITEMFLAG1_CHILDRENVISIBLE    0x00000200 //czy maj by widoczne dzieci danej sekcji lub grupy mimo jej niewidocznoci
#define CONTACTLIST_ITEMFLAG1_DEFAULTCONTACT     0x00000400 //standardowy kontakt
#define CONTACTLIST_ITEMFLAG1_OWNERSORT          0x00000800 //czy ma stosowa funkcj callback do sortowania dzieci danej pozycji
#define CONTACTLIST_ITEMFLAG1_HIDDENIFEMPTY      0x00001000 //czy ma by ukryta (grupa, sekcja), jeli nie ma adnych dzieci
#define CONTACTLIST_ITEMFLAG1_OWNERHEIGHT        0x00002000 //czy ma wywoywa funckje callback dla pobrania wysokoci elementu
#define CONTACTLIST_ITEMFLAG1_SELECTED           0x00004000 //czy jest zaznaczony w danym momencie
#define CONTACTLIST_ITEMFLAG1_NODESC_LIMIT       0x00008000 //nie ucinaj opisu na liscie
#define CONTACTLIST_ITEMFLAG1_HINT_SHOW_NAME     0x00010000 //pokazuj nazwe kontaktu w hincie
// np jesli nazwa nie zmiescila sie na liscie kontaktow
#define CONTACTLIST_ITEMFLAG1_DRAG_OVER          0x00020000 //oznacza element nad ktorym
#define CONTACTLIST_ITEMFLAG1_NO_HINT_AVATAR     0x00040000
#define CONTACTLIST_ITEMFLAG1_ACTIVE             0x00080000
// jest przenoszony inny kontakt

#define CONTACTLIST_ITEMFLAG2_ONLINE             0x00000001 //dostpny
#define CONTACTLIST_ITEMFLAG2_OFFLINE            0x00000002 //niedostpny
#define CONTACTLIST_ITEMFLAG2_WAITAUTH           0x00000004 //oczekiwanie na autoryzacj
#define CONTACTLIST_ITEMFLAG2_NOTAUTH            0x00000008 //brak autoryzacji
#define CONTACTLIST_ITEMFLAG2_PHONE              0x00000010 //numer telefonu
#define CONTACTLIST_ITEMFLAG2_NOTINLIST          0x00000020 //spoza listy kontaktw
#define CONTACTLIST_ITEMFLAG2_BLOCKED            0x00010000 //zablokowany

//flagi do zmiany parametrw pozycji
#define CONTACTLIST_ITEMCHANGEFLAG_SECTIONHANDLE      0x00000001
#define CONTACTLIST_ITEMCHANGEFLAG_GROUPHANDLE        0x00000002
#define CONTACTLIST_ITEMCHANGEFLAG_PREVIOUSHANDLE     0x00000004
#define CONTACTLIST_ITEMCHANGEFLAG_ITEMKIND           0x00000008
#define CONTACTLIST_ITEMCHANGEFLAG_ITEMSUBKIND        0x00000010
#define CONTACTLIST_ITEMCHANGEFLAG_FLAGS1             0x00000020
#define CONTACTLIST_ITEMCHANGEFLAG_FLAGS2             0x00000040
#define CONTACTLIST_ITEMCHANGEFLAG_FLAGS3             0x00000080
#define CONTACTLIST_ITEMCHANGEFLAG_MAINTEXT           0x00000100
#define CONTACTLIST_ITEMCHANGEFLAG_SECONDARYTEXT      0x00000200
#define CONTACTLIST_ITEMCHANGEFLAG_LOWERTEXT          0x00000400
#define CONTACTLIST_ITEMCHANGEFLAG_ITEMHINT           0x00000800
#define CONTACTLIST_ITEMCHANGEFLAG_CONTACTINFO        0x00001000
#define CONTACTLIST_ITEMCHANGEFLAG_MENUID             0x00002000
#define CONTACTLIST_ITEMCHANGEFLAG_CALLBACKFUNC       0x00004000
#define CONTACTLIST_ITEMCHANGEFLAG_CALLBACKCOMPFUNC   0x00008000
#define CONTACTLIST_ITEMCHANGEFLAG_OWNERDATA          0x00010000
#define CONTACTLIST_ITEMCHANGEFLAG_REDRAWITEM         0x10000000
#define CONTACTLIST_ITEMCHANGEFLAG_NOLISTUPDATE       0x20000000
#define CONTACTLIST_ITEMCHANGEFLAG_ITEMNEWHINT        0x40000000
#define CONTACTLIST_ITEMCHANGEFLAG_AVATAR             0x80000000

//Funkcja CallBack

typedef struct {

 int structSize;		//wielko strutkury w bajtach

 int Event;                     //kod zdarzenia
 ContactListItemDef *Item;

} ItemCallBackEventDef; //idzie zawsze jako WPARAM w callbacku

#define CONTACTLIST_ITEMCALLBACK_GETHEIGHT      1 //pobiera wysokosc elementu
//LPARAM NULL

#define CONTACTLIST_ITEMCALLBACK_DRAWITEM       2 //prosi o narysowanie pozycji, jeli item jest typu ownerdrawn
//LPARAM
typedef struct {

 int structSize;		//wielko strutkury w bajtach

 RECT *itemRect;
 HDC itemHdc;

} ItemCallBackOwnerDrawnDef;

#define CONTACTLIST_ITEMCALLBACK_CANSELECTITEM  3 //czy mona zaznaczy dany zestaw
//LPARAM NULL

//ponisze definicje s wykorzystane rwnie przy callbackach ikonek
#define CONTACTLIST_ITEMCALLBACK_MOUSEENTER     101
#define CONTACTLIST_ITEMCALLBACK_MOUSEEXIT      102
#define CONTACTLIST_ITEMCALLBACK_MOUSEMOVE      103
#define CONTACTLIST_ITEMCALLBACK_MOUSEDOWN      104
#define CONTACTLIST_ITEMCALLBACK_MOUSEUP        105
#define CONTACTLIST_ITEMCALLBACK_MOUSEDBLCLK    106

//LPARAM
typedef struct {

 int structSize;		//wielko strutkury w bajtach

 POINT Position;
 int MouseButton;

 ContactListIconDef *Icon;      //jeli zdarzenie dotyczy jakiej ikonki

} ItemCallBackMouseDef;

#define MOUSE_BUTTON_LEFT       1
#define MOUSE_BUTTON_RIGHT      2
#define MOUSE_BUTTON_MIDDLE     3

#define CONTACTLIST_ITEMCALLBACK_KEYDOWN        201
#define CONTACTLIST_ITEMCALLBACK_KEYUP          202
//LPARAM
typedef struct {

 int structSize;		//wielko strutkury w bajtach

 int Key;
 int KeyData;

} ItemCallBackKeyDef;


//Dodaje pozycj do listy kontaktw
//WPARAM - ContactListItemDef *
#define TLEN_CONTACTLIST_ADDITEM                "Tlen/ContactList/AddItem"

//Usuwa pozycj z listy kontaktw
//WPARAM - ItemHandle
#define TLEN_CONTACTLIST_REMOVEITEM             "Tlen/ContactList/RemoveItem"

//zwraca wskanik do elementu - ContactListItemDef *
//WPARAM - ItemHandle
#define TLEN_CONTACTLIST_GETITEM                "Tlen/ContactList/GetItem"

//Jako WPARAM idzie ItemHandle, jako LPARAM ContactListItemDef * z parametrami do zmiany
#define TLEN_CONTACTLIST_CHANGEITEM             "Tlen/ContactList/ChangeItem"

// zwraca handle dla elementu zwraca ItemHandle
// WPARAM ContactDef
#define TLEN_CONTACTLIST_FINDITEM               "Tlen/ContactList/FindItem"

//zwraca elementy listy kontaktw
//Jako WPARAM:
typedef struct {

        int structSize;         //wielko strutkury w bajtach

        int EnumerationKind;

        int ParentHandle;
        TLENFUNCTION CallbackFunc;
        void *OwnerValue;

} ContactListItemsEnumerationDef;

#define CONTACTLIST_ENUMERATIONKIND_CHILDREN            1
#define CONTACTLIST_ENUMERATIONKIND_VISIBLE             2
#define CONTACTLIST_ENUMERATIONKIND_ALL                 3

#define TLEN_CONTACTLIST_ENUMERATEITEMS     "Tlen/ContactList/EnumerateItems"

//Dodaje ikonki do pozycji
//WPARAM:
typedef struct {

 int structSize;		//wielko strutkury w bajtach

 int ItemHandle;                //uchwyt elementu
 ContactListIconDef *Icons;     //wskanik do ikonki/ikonek
 int IconsCount;                //liczba dodawanych ikonek

} AddItemIconsDef;

#define TLEN_CONTACTLIST_ADDITEMICONS           "Tlen/ContactList/AddItemIcons"

//Usuwa ikonk
//WPARAM - ItemHandle, LPARAM - IconID ("***" na kocu oznacza, e ma usun wszystkie ikonki majace rozpoczynajce si na podany cig liter ID)
#define TLEN_CONTACTLIST_REMOVEITEMICON         "Tlen/ContactList/RemoveItemIcon"

//Zmienia parametry ikonki
//WPARAM - ItemHandle, LPARAM - ContactListIconDef *
#define TLEN_CONTACTLIST_CHANGEITEMICON         "Tlen/ContactList/ChangeItemIcon"

//Wylicza ikonki nalece do kontaktu
//WPARAM - ContactListItemsEnumerationDef *
#define TLEN_CONTACTLIST_ENUMERATEITEMICONS     "Tlen/ContactList/EnumerateItemIcons"

//Przerysowuje pozycj
//WPARAM - ItemHandle
#define TLEN_CONTACTLIST_REDRAWITEM             "Tlen/ContactList/RedrawItem"

//Przerysowuje ca list
#define TLEN_CONTACTLIST_REDRAWLIST             "Tlen/ContactList/RedrawList"

//Zwraca warto danego parametru
//WPARAM - ID parametru, LPARAM - wskanik do zmiennej, ktra otrzyma warto
#define TLEN_CONTACTLIST_GETPROPERTY            "Tlen/ContactList/GetProperty"

//Ustawia warto danego parametru
//WPARAM - ID parametru, LPARAM - wskanik do zmiennej
#define TLEN_CONTACTLIST_SETPROPERTY            "Tlen/ContactList/SetProperty"

//ID parametrw
#define TLEN_CONTACTLIST_PROPERTY_STATUSBARVISIBLE              1
#define TLEN_CONTACTLIST_PROPERTY_GROUPVISIBLE                  2
#define TLEN_CONTACTLIST_PROPERTY_OFFLINEVISIBLE                3
#define TLEN_CONTACTLIST_PROPERTY_STATUSTEXTVISIBLE             4
#define TLEN_CONTACTLIST_PROPERTY_DRAWINGENABLED                5 //czy lista przerysowuje si



//Hook - otrzymujemy zdarzenia dotyczce elementw listy
#define TLEN_CONTACTLIST_NOTIFICATION           "Tlen/ContactList/Notification"
//WPARAM
#define BEFORE_ITEM_ADD                 1 //jako LPARAM idzie struktura ContactListItemDef *
#define AFTER_ITEM_ADD                  2 //jako LPARAM idzie struktura ContactListItemDef *
#define BEFORE_ITEM_REMOVE              3 //jako LPARAM idzie struktura ContactListItemDef *
#define AFTER_ITEM_REMOVE               4 //jako LPARAM idzie struktura ContactListItemDef *

#define BEFORE_ITEM_CHANGE              5
#define AFTER_ITEM_CHANGE               6
//Tu jako LPARAM idzie:
typedef struct {

 int structSize;		//wielko strutkury w bajtach

 ContactListItemDef *OldItem;
 ContactListItemDef *NewItem;

} ItemChangeDef;

#endif
