#ifndef plugin_optionsH
#define plugin_optionsH

#include <windows.h>

#include "plugin_struct.h"
//------------------------------------------------------------------------------------------

typedef struct {

 int structSize;

 char *ID;
 char *ParentID;        //Nadrzdna zakadka - Nie obsugiwane jeszcze

 char *Caption;

 int Flags;

 int Position;          //Pozycja zakadki - Nie obsugiwane jeszcze
 HBITMAP Icon;          //Ikonka pokazywana na liscie zakladek (16x16)
 TLENFUNCTION CallBack;

 void *OwnerData;

} TlenOptionPageDefinition;

#define TLEN_OPTIONS_PAGEDEF_FLAG_TLENCOLOR     1 //okienko w kolorze tlenowym
#define TLEN_OPTIONS_PAGEDEF_FLAG_ICONTRANS     2 //ikonka z przezroczystym tem
#define TLEN_OPTIONS_PAGEDEF_FLAG_BASICOPT      4 //pokazywa pozycj gdy uytkownik w trybie podstawowym opcji (Nie obsugiwane jeszcze)
#define TLEN_OPTIONS_PAGEDEF_FLAG_ADVANCEDOPT   8 //pokazywa gdy user w trybie zaawansowanym (Nie obsugiwane jeszcze)

typedef struct {

 int structSize;

 TlenOptionPageDefinition *Page; //kliknita zakadka
 int Action; //akcja

 HWND Handle; //w tym oknie naley umieci wasne okienko
 void *PHandle;

 //pozycja i rozmiar naszego okienka
 int x;
 int y;
 int width;
 int height;
 COLORREF bgColor; //kolor ta okienka opcji tlenowych

 int Flags;

 //pola wypeniane przez plugin
 char Caption[256];             //Nazwa zakadki
 char Description[1024];        //Opis danej zakadki
 HBITMAP Icon;                  //Ikonka pokazywana przed nazw i opisem (32x32)

} TlenOptionPageShowInfo;

#define TLEN_OPTIONS_PAGEINFO_FLAG_ADVANCED     1 //Nie obsugiwane jeszcze
#define TLEN_OPTIONS_PAGEINFO_FLAG_ICONTRANS    2 //ikonka z przezroczystym tem

#define TLEN_OPTIONS_PAGE_ACTION_SHOW           1 //Pokazac okienko
#define TLEN_OPTIONS_PAGE_ACTION_HIDE           2 //Schowac okienko
#define TLEN_OPTIONS_PAGE_ACTION_OK             3 //Kliknieto OK
#define TLEN_OPTIONS_PAGE_ACTION_APPLY          4 //Kliknieto Zastosuj
#define TLEN_OPTIONS_PAGE_ACTION_CANCEL         5 //Kliknieto Anuluj


// sprawdza czy dany kontakt jest blokowany
#define TLEN_OPTIONS_USER_IGNORED     "Tlen/OptionsUserIgnored"

// zwraca 1 jesli okno rozmowy ma zakladki
#define TLEN_OPTIONS_CHAT_TABS "Tlen/OptionsChatTabs"


//Dodaje zakladke do opcji
//WPARAM - HINSTANCE pluginu, LPARAM - TlenOptionPageDefinition *
#define TLEN_ADD_OPTIONS_PAGE                   "Tlen/AddOptionsPage"
//Usuwa zakladki pluginu (wszystkie)
//WPARAM - HINSTANCE pluginu
#define TLEN_REMOVE_OPTIONS_PAGES               "Tlen/RemoveOptionsPages"

//Dodaje uchwyt okienka, aby obslugiwac poprawnie klawiature wewnatrz okienka
//WPARAM - HANDLE okienka
#define TLEN_ADD_DIALOG_HANDLE                  "Tlen/AddDialogHandle"
//Kasuje uchwyt okienka z listy
//WPARAM - HANDLE okienka
#define TLEN_REMOVE_DIALOG_HANDLE               "Tlen/RemoveDialogHandle"

/* Nie obslugiwane jeszcze */
//Przeprowadza dzialanie na okienku opcji
#define TLEN_OPTIONS_PERFORM_ACTION             "Tlen/OptionsPerformAction"

//Pokazuje/chowa okno opcji
#define TLEN_OPTIONS_ACTION_SHOW           1
//Zmienia widoczna zakladke
#define TLEN_OPTIONS_ACTION_SWITCHPAGE     2
//Symuluje nacisniecie OK
#define TLEN_OPTIONS_ACTION_OK             3
//Symuluje nacisniecie Zastosuj
#define TLEN_OPTIONS_ACTION_APPLY          4
//Symuluje nacisniecie Anuluj
#define TLEN_OPTIONS_ACTION_CANCEL         5

//------------------------------------------------------------------------------------------

#endif