#ifndef plugin_procaddrH
#define plugin_procaddrH

#include <windows.h>

//Pobiera adres funkcji z tlenu
//WPARAM - identyfikator funkcji
#define TLEN_GET_PROC_ADDRESS           "Tlen/GetProcAddress"

//Operacje na StringListDef *

#define TPA_SL_INIT                     0x00001001
#define TPA_SL_ADD                      0x00001002
#define TPA_SL_DELETE                   0x00001003
#define TPA_SL_GET                      0x00001004
#define TPA_SL_FIND                     0x00001005
#define TPA_SL_FREE                     0x00001006
#define TPA_SL_ADDSTRINGS               0x00001007
#define TPA_SL_COMMONPART               0x00001008

//Operacje na ContactDef *

#define TPA_CT_INIT                     0x00002001
#define TPA_CT_FREE                     0x00002002
#define TPA_CT_COPY                     0x00002003

//Operacje na ContactsListDef *

#define TPA_CL_INIT                     0x00002101
#define TPA_CL_ADD                      0x00002102
#define TPA_CL_COPY                     0x00002103
#define TPA_CL_FREE                     0x00002104

//Rne przydatne funkcje
#define TPA_SHA1                        0x00010001
#define TPA_MYHASH                      0x00010002

//pobieranie informacji o profilu
#define TPA_GET_PROF_INFO               0x00020001

//Zwraca: ProfInfoDef *
typedef struct {

 int structSize;

 char *Login;
 char *ProfileName;
 char *ProfileDirPath;

} ProfInfoDef;

/* Sposb uycia:

TLENFUNCTION f = (TLENFUNCTION) tlen_functions->CallTlenFunction(hInst, TLEN_GET_PROC_ADDRESS, TPA_GET_PROF_INFO, NULL);
if (f)
{
 ProfInfoDef *prof_info = (ProfInfoDef *) f(NULL, NULL);
}
*/

//czy danemu kontaktowi przypisany jest kontakt smsowy
#define TPA_GET_SMS_NUMBER              0x00030001

//czy danemu numerowi przypisany jest kontakt jakis
#define TPA_GET_SMS_NUMBER_CONTACT      0x00030002

/**
 * Pobranie wyswietlanej nazwy danego kontaktu.
 * WPARAM Wskaznik do struktury ContactDef,
 * LPARAM 0
 */
#define TPA_GET_CONTACT_NAME            0x00030003

/**
 * Pobranie statusu dla danego kontaktu.
 * WPARAM Wskaznik do struktury ContactDef,
 * LPARAM 0
 */
#define TPA_GET_CONTACT_STATUS_TEXT     0x00030004



#define TPA_GET_PROFILE_INFO            0x01000001

#define TPA_GET_CONNECTION_INFO         0x01000002

typedef struct {

 int structSize;

 int    ConnectionFlag;
 char   ProxyHost[512];
 int    ProxyPort;
 char   ProxyUser[128];
 char   ProxyPassword[128];

} ConnectionInfoDef;

#define CONNECTIONKIND_FLAG_MODEM       0x00000001
#define CONNECTIONKIND_FLAG_LAN         0x00000002

#define CONNECTIONKIND_FLAG_PROXY       0x00000010
#define CONNECTIONKIND_FLAG_PROXYAUTH   0x00000020

#define CONNECTIONKIND_FLAG_CONNECTED   0x00000100

//--------------------------------------------------------------
//STRING ID, return: char *string
#define TPA_GET_TRANSLATEDSTRING        0x02000001

#endif



