//---------------------------------------------------------------------------
#ifndef plugin_skinH
#define plugin_skinH
//---------------------------------------------------------------------------

#include <windows.h>

typedef struct {

 int structSize;		        //wielko strutkury w bajtach

 char *SkinID;                          //jeli to jest grafika skrkowalna, to wystarczy poda tu jej skinID
                                        //przy zmianie skrki automatycznie zostanie zmieniona

 HBITMAP Bitmap;                        //bitmapa
 COLORREF Transparent;                  //kolor przezroczystoci
 RECT Location;                         //pooenie grafiki na bitmapie

} TlenSingleImageDef;

#define TLEN_SKIN_GETSKINNEDIMAGE          "Tlen/Skin/GetSkinnedImage"
//jako WPARAM idzie struktura do ktorej przekazywane sa dane grafiki (TlenSingleImageDef)
//musi byc wypelnione SkinID

//identyfikatory ikonek

#define icIDTlenStatus       "ic/TL"

#define icIDTlenOnline       "ic/TL/Online"
#define icIDTlenChat         "ic/TL/Chat"
#define icIDTlenAway         "ic/TL/Away"
#define icIDTlenXA           "ic/TL/XA"
#define icIDTlenDND          "ic/TL/DND"
#define icIDTlenInvisible    "ic/TL/Invisible"
#define icIDTlenOffline      "ic/TL/Offline"
#define icIDTlenOnline_ST    "ic/TL/Online/ST"
#define icIDTlenChat_ST      "ic/TL/Chat/ST"
#define icIDTlenAway_ST      "ic/TL/Away/ST"
#define icIDTlenXA_ST        "ic/TL/XA/ST"
#define icIDTlenDND_ST       "ic/TL/DND/ST"
#define icIDTlenInvisible_ST "ic/TL/Invisible/ST"
#define icIDTlenOffline_ST   "ic/TL/Offline/ST"

#define icIDGGStatus         "ic/GG"

#define icIDGGOnline         "ic/GG/Online"
#define icIDGGAway           "ic/GG/Away"
#define icIDGGInvisible      "ic/GG/Invisible"
#define icIDGGOffline        "ic/GG/Offline"
#define icIDGGOnline_ST      "ic/GG/Online/ST"
#define icIDGGAway_ST        "ic/GG/Away/ST"
#define icIDGGInvisible_ST   "ic/GG/Invisible/ST"
#define icIDGGOffline_ST     "ic/GG/Offline/ST"

#define icIDMetaStatus       "ic/Meta"

#define icIDMetaOnline       "ic/Meta/Online"
#define icIDMetaChat         "ic/Meta/Chat"
#define icIDMetaAway         "ic/Meta/Away"
#define icIDMetaXA           "ic/Meta/XA"
#define icIDMetaDND          "ic/Meta/DND"
#define icIDMetaInvisible    "ic/Meta/Invisible"
#define icIDMetaOffline      "ic/Meta/Offline"
#define icIDMetaOnline_ST    "ic/Meta/Online/ST"
#define icIDMetaChat_ST      "ic/Meta/Chat/ST"
#define icIDMetaAway_ST      "ic/Meta/Away/ST"
#define icIDMetaXA_ST        "ic/Meta/XA/ST"
#define icIDMetaDND_ST       "ic/Meta/DND/ST"
#define icIDMetaInvisible_ST "ic/Meta/Invisible/ST"
#define icIDMetaOffline_ST   "ic/Meta/Offline/ST"


#define icIDPhone            "ic/Phone"
#define icIDClosedGroup      "ic/ClosedGroup"
#define icIDOpenedGroup      "ic/OpenedGroup"

#define icIDVoice            "ic/Voice"
#define icIDVideo            "ic/Video"
#define icIDFileSend         "ic/FileSend"


/**
 * Typy skorkowalnych okienek.
 */
typedef enum
{
	SKIN_WINDOW_NONE = 0,
	SKIN_WINDOW_MAIN,
	SKIN_WINDOW_CHAT,
	SKIN_WINDOW_CONF

} TlenSkinWindowType;

/**
 * Rodzaje elementow skorek.
 */
typedef enum
{
	TLEN_SKIN_ELEMENT_NONE = 0,
	TLEN_SKIN_ELEMENT_STATIC,
	TLEN_SKIN_ELEMENT_BUTTON,
	TLEN_SKIN_ELEMENT_SCROLLBAR,
	TLEN_SKIN_ELEMENT_CONTACTBOX,
	TLEN_SKIN_ELEMENT_LABEL,
	TLEN_SKIN_ELEMENT_AREAFILL,
	TLEN_SKIN_ELEMENT_STATUSBOX,
	TLEN_SKIN_ELEMENT_EX_LABEL,
	TLEN_SKIN_ELEMENT_EX_STATIC,
	TLEN_SKIN_ELEMENT_GRAPHIC,
	TLEN_SKIN_ELEMENT_ICON,
	TLEN_SKIN_ELEMENT_TABBAR,
	TLEN_SKIN_ELEMENT_TAB

} TlenSkinElementType;

/**
 * Flagi dla elementow skorek.
 */
enum
{
	TLEN_SKIN_ELEMENT_FLAG_NONE = 0,
	TLEN_SKIN_ELEMENT_FLAG_VISIBLE = (1 << 0)

};

/**
 * Flagi dla zmiany elementow skorek.
 */
enum
{
	TLEN_SKIN_ELEMENT_CHANGE_NONE = 0,
	TLEN_SKIN_ELEMENT_CHANGE_UPDATENOW = (1 << 0),
	TLEN_SKIN_ELEMENT_CHANGE_FLAG = (1 << 1),
	TLEN_SKIN_ELEMENT_CHANGE_HINT = (1 << 2),
	TLEN_SKIN_ELEMENT_CHANGE_SET = (1 << 3),
	TLEN_SKIN_ELEMENT_CHANGE_TEXT = (1 << 4)

};

/**
 * Typy zdarzen.
 */
typedef enum
{
	TLEN_SKIN_EVENT_NONE = 0,
	TLEN_SKIN_EVENT_MOUSE,
	TLEN_SKIN_EVENT_LOADED

} TlenSkinEventType;

/**
 * Typy zdarzen myszki.
 */
typedef enum
{
	TLEN_SKIN_MOUSE_NONE = 0,
	TLEN_SKIN_MOUSE_LB_DOWN,
	TLEN_SKIN_MOUSE_LB_UP,
	TLEN_SKIN_MOUSE_LB_DBLCLK,
	TLEN_SKIN_MOUSE_RB_DOWN,
	TLEN_SKIN_MOUSE_RB_UP,
	TLEN_SKIN_MOUSE_RB_DBLCLK,
	TLEN_SKIN_MOUSE_MB_DOWN,
	TLEN_SKIN_MOUSE_MB_UP,
	TLEN_SKIN_MOUSE_MB_DBLCLK,
	TLEN_SKIN_MOUSE_ENTER,
	TLEN_SKIN_MOUSE_LEAVE

} TlenSkinMouseType;

/**
 * Struktura skorkowalnego elementu.
 */
typedef struct
{
	/**
	 * Wielkosc struktury.
	 */
	int structSize;

	/**
	 * Typ okienka.
	 */
	TlenSkinWindowType windowType;

	/**
	 * Id elementu.
	 */
	char *elemID;

	/**
	 * Typ elementu.
	 */
	TlenSkinElementType elemType;

	/**
	 * Aktualny dymek elementu.
	 */
	char *hint;

	/**
	 * Flaga.
	 */
	int flag;

	/**
	 * Flaga do zmiany wlasciwosci elementu.
	 */
	int changeFlag;

	/**
	 * Zestaw przycisku lub ikonki.
	 */
	int set;

	/**
	 * Tekst elementu etykiety.
	 */
	char *text;

} TlenSkinElement;


typedef struct
{
	/**
	 * Wielkosc struktury.
	 */
	int structSize;

	/**
	 * Typ okienka.
	 */
	TlenSkinWindowType windowType;

	/**
	 * Nazwa skorki.
	 */
	char *skinName;

}TlenSkin;

/**
 * Struktura zdarzenia.
 */
typedef struct
{
	/**
	 * Wielkosc struktury.
	 */
	int structSize;

	/**
	 * Typ okienka.
	 */
	TlenSkinWindowType windowType;

	/**
	 * Rodzaj zdarzenia.
	 */
	TlenSkinEventType eventType;

	/**
	 * Wskaznik do dodatkowych danych.
	 */
	void *extra_data;

} TlenSkinEvent;

/**
 * Struktura zdarzenia myszki.
 */
typedef struct
{
	/**
	 * Wielkosc struktury.
	 */
	int structSize;

	/**
	 * Id elementu.
	 */
	char *elemID;

	/**
	 * Typ zdarzenia myszki.
	 */
	TlenSkinMouseType mouse;

} TlenSkinMouseEvent;

/**
 * Struktura zdarzenia zaladowania skorki.
 */
typedef struct
{
	/**
	 * Wielkosc struktury.
	 */
	int structSize;

	/**
	 * Nazwa wczytywanej skorki.
	 */
	char *skinName;

} TlenSkinLoadedEvent;

/**
 * Definicja funckji otrzymujacej zdarzenia.
 * @param event Wskaznik do struktury zdarzenia.
 * @param data Wskaznik do danych zdarzenia, zalezne od 'eventType'.
 * @return 0 - przetwarzaj dalej zdarzenia, 1 - nie przetwarzaj dalej.
 */
typedef int (*TlenSkinCallback) (TlenSkinEvent *event, void *data);

/**
 * Struktura do podczepienia sie pod zdarzenia.
 */
typedef struct
{
	/**
	 * Wielkosc struktury.
	 */
	int structSize;

	/**
	 * Typ okienka.
	 */
	TlenSkinWindowType windowType;

	/**
	 * Id elementu.
	 */
	char *elemID;

	/**
	 * Wskaznik do funkcji, ktora bedzie otrzymywac zdarzenia.
	 */
	TlenSkinCallback callback;

	/**
	 * Wskaznik do dodatkowych danych.
	 */
	void *extra_data;

} TlenSkinHook;


/**
 * Zaladowanie skorki.
 * WPARAM Wskaznik do struktury 'TlenSkin'.
 * LPARAM NULL.
 */
#define TLEN_SKIN_LOAD           "Tlen/Skin/Load"

/**
 * Pobranie listy nazw skorek.
 * WPARAM Wskaznik do struktury 'TlenSkin',
 *        wypelnic 'windowType'.
 * LPARAM Wskaznik do struktury 'StringListDef'.
 */
#define TLEN_SKIN_GET_SKINS_NAMES           "Tlen/Skin/GetSkinsNames"

/**
 * Pobranie listy id elementow.
 * WPARAM Wskaznik do struktury 'TlenSkin',
 *        wypelnic 'windowType'.
 * LPARAM Wskaznik do struktury 'StringListDef'.
 */
#define TLEN_SKIN_GET_ELEMENTS_IDS           "Tlen/Skin/GetElementsIDs"

/**
 * Pobranie danych dla elementu
 * WPARAM Wskaznik do struktury 'TlenSkinElement',
 *        nalezy wypelnic elemID.
 */
#define TLEN_SKIN_GET_ELEMENT           "Tlen/Skin/GetElement"

/**
 * Zmiana wlasciwosci elementu.
 * WPARAM Wskaznik do struktury 'TlenSkinElement'.
 */
#define TLEN_SKIN_CHANGE_ELEMENT          "Tlen/Skin/ChangeElement"

/**
 * Podczepienie sie pod zdarzenia.
 * WPARAM Wskaznik do struktury 'TlenSkinHook',
 *        ustawiajc tylko windowType podczepiamy sie
 *        pod wszystkie komunikaty z danego typu okna ...
 * LPARAM NULL
 *
 */
#define TLEN_SKIN_HOOK_EVENTS          "Tlen/Skin/HookEvent"

/**
 * Kasuje podczepienie sie pod zdarzenia.
 * WPARAM Wskaznik do struktury 'TlenSkinHook'.
 * LPARAM NULL.
 */
#define TLEN_SKIN_UNHOOK_EVENTS        "Tlen/Skin/UnHookEvent"




#endif