#ifndef plugin_structH
#define plugin_structH

#include <windows.h>

//Maksymalna dugo nazwy funkcji, zdarzenia
#define MAXNAMELENGTH 64

//Tworzy wersje w postaci DWORD
#define MAKE_DWORD_VERSION(a,b,c,d)   ((DWORD)a&0xFF)<<24|((DWORD)b&0xFF)<<16|((DWORD)c&0xFF)<<8|((DWORD)d&0xFF)

//Wersja API
#define PLUGIN_API_VERSION MAKE_DWORD_VERSION(0,1,8,4)

//Makro do inicjalizacji struktur
#define InitializeStruct(st) {memset(&st,0,sizeof(st));st.structSize=sizeof(st);};

typedef int (*TLENHOOK)(WPARAM,LPARAM);
typedef int (*TLENFUNCTION)(WPARAM,LPARAM);

typedef struct {

	int structSize;

	char *PluginName;

    DWORD PluginAPIVersion;
	DWORD PluginVersion;
	char *PluginDescription;
	char *PluginCopyright;

	char *PluginAuthor;
	char *PluginAuthorEmail;
	char *PluginAuthorHomepage;

	DWORD Reserved1;
	DWORD Reserved2;
	DWORD Reserved3;
	DWORD Reserved4;

} TLENPLUGININFO;

typedef struct {

	HANDLE          (*CreateTlenFunction)  (HINSTANCE, const char *,TLENFUNCTION);
	int             (*DestroyTlenFunction) (HINSTANCE, HANDLE);
	int             (*CallTlenFunction)    (HINSTANCE, const char *,WPARAM,LPARAM);
	int             (*CallTlenFunctionTS)  (HINSTANCE, const char *,WPARAM,LPARAM);
	int             (*TlenFunctionExists)  (HINSTANCE, const char *);

	HANDLE (*CreateTlenEvent)     (HINSTANCE, const char *);
	int    (*DestroyTlenEvent)    (HINSTANCE, HANDLE);
	int    (*NotifyTlenHooks)     (HINSTANCE, HANDLE,WPARAM,LPARAM);
	HANDLE (*HookTlenEvent)       (HINSTANCE, const char *,TLENHOOK);
	HANDLE (*HookTlenEventMessage)(HINSTANCE, const char *,HWND,UINT);
	int    (*UnhookTlenEvent)     (HINSTANCE, HANDLE);

} TLENPLUGINFUNCTIONS;

//Gdy wszystkie pluginy zostan zaadowane
#define TLEN_PLUGINS_LOADED_EVENT       "Tlen/PluginsLoadedEvent"

#endif
