/* ==========================================================================
 * Name:        tlenek\defs.h
 * Purpose:     Glowne (globalne) deklaracje i makra uzywane w bibliotece
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     24/09/2007 04:08:36 (extracted from tlenek\plugin.h)
 * SVN-ID:      $Id: defs.h 18 2007-10-19 15:08:56Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#ifndef _TLENEK_DEFS_H_
#define _TLENEK_DEFS_H_


#ifdef TLENEK_DLL_EXPORTS
	#define TLENEK_DLLIMPEXP __declspec(dllexport)
#elif defined TLENEK_DLL_IMPORTS
	#define TLENEK_DLLIMPEXP __declspec(dllimport)
#else
	#define TLENEK_DLLIMPEXP
#endif


#ifdef TLENEK_USE_MFC
	#define TLENEK_AFX AFX_MANAGE_STATE(AfxGetStaticModuleState());
#else
	#define TLENEK_AFX
#endif


#include "tlen_sdk\plugin_defs.h"
#include "tlen_sdk\plugin_struct.h"


#define WIN32_LEAN_AND_MEAN		// exclude rarely-used stuff from Windows headers


#if defined _MSC_VER && _MSC_VER < 1300
	// warning C4786: identifier was truncated to '255' characters in the browser information
	#pragma warning(disable:4786)
#endif

#if defined _MSC_VER && _DEBUG
	// warning C4251: needs to have dll-interface to be used by clients
	// uzywamy STL-a wewnetrznie, wiec mozemy zignorowac te ostrzezenia
	// ale na wszelki wypadek tylko w wersji debug
	#pragma warning(disable:4251)
#endif


#endif // _TLENEK_DEFS_H_
