/* ==========================================================================
 * Name:        tlenek\dialoghandle.h
 * Purpose:     Deklaracja klasy DialogHandle zarzadzajacej uchwytami okienek
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     14/11/2007 22:35:48
 * SVN-ID:      $Id: dialoghandle.h 21 2007-11-14 23:28:50Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#ifndef _TLENEK_DIALOG_HANDLE_H_
#define _TLENEK_DIALOG_HANDLE_H_

#include "tlenek\defs.h"
#include "tlenek\tlen.h"
#include "tlenek\function.h"
#include "tlen_sdk\plugin_options.h"
#include <list>


namespace tlenek {


class TLENEK_DLLIMPEXP DialogHandle {

	private:

		typedef std::list<HWND> en_list_t;
		en_list_t m_list;

		DialogHandle() {}
		~DialogHandle() {}


	public:

		void Add(const HWND hwnd) {
			Tlen::Get()->GetFunction()->CallTS(TLEN_ADD_DIALOG_HANDLE, (WPARAM) hwnd, NULL);
		}

		void Del(const HWND hwnd) {
			Tlen::Get()->GetFunction()->CallTS(TLEN_REMOVE_DIALOG_HANDLE, (WPARAM) hwnd, NULL);
		}

		void DelAll();


		int Count() {
			return m_list.size();
		}


	friend class Tlen;

};


} // namespace tlenek


#endif // _TLENEK_DIALOG_HANDLE_H_
