/* ==========================================================================
 * Name:        tlenek\exception.h
 * Purpose:     Deklaracja klasy Exception
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     01/10/2007 18:28:38
 * SVN-ID:      $Id: exception.h 11 2007-10-11 13:10:36Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#ifndef _TLENEK_EXCEPTION_H_
#define _TLENEK_EXCEPTION_H_

#include "tlenek\defs.h"
#include "tlenek\utils.h"


namespace tlenek {


	enum ExcCode {
		UNKNOWN = 0,
		VALIDINDEX,
	};


// throw Exception(VALIDINDEX, NULL, "ContactIcon::SetState", __LINE__, __FILE__);

class TLENEK_DLLIMPEXP Exception {

	private:

		int m_code;
		char* m_msg;
		char* m_func;
		int m_line;
		char* m_file;


	public:

		Exception(ExcCode code = UNKNOWN, const char* msg = NULL, const char* func = NULL, 
					int line = 0, const char* file = NULL);

		~Exception();


		ExcCode GetCode() const {
			return (ExcCode) m_code;
		}


		const char* what() {
			return m_msg;
		}

		void show();

};


} // namespace tlenek


#endif // _TLENEK_EXCEPTION_H_
