/* ==========================================================================
 * Name:        tlenek\misc.h
 * Purpose:     Deklaracje innych, przydatnych tlenowych funkcji
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     20/09/2007 16:30:03
 * SVN-ID:      $Id: misc.h 10 2007-10-10 19:03:31Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#ifndef _TLENEK_MISC_H_
#define _TLENEK_MISC_H_

#include "tlenek\defs.h"
#include "tlenek\plugin.h"


namespace tlenek {


	inline HINSTANCE GetPluginInstance() {
		return Plugin::GetInstance()->GetPluginInstance();
	}


	inline TLENPLUGINFUNCTIONS* GetTlenFunctions() {
		return Plugin::GetInstance()->GetTlenFunctions();
	}


	// generuje hasz algorytmem SHA1
	TLENEK_DLLIMPEXP const char* SHA1(const char* string);

	// generuje hasz algorytmem uzywanym przez tlen
	// do haszowania hasla w czasie autoryzacji do sieci
	TLENEK_DLLIMPEXP const char* HASH(const char* string);


} // namespace tlenek


#endif // _TLENEK_MISC_H_
