/* ==========================================================================
 * Name:        tlenek\protocolinfo.h
 * Purpose:     Deklaracja klasy ProtocolInfo
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     08/10/2007 20:23:07
 * SVN-ID:      $Id: protocolinfo.h 8 2007-10-08 20:18:38Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#ifndef _TLENEK_PROTOCOL_INFO_H_
#define _TLENEK_PROTOCOL_INFO_H_

#include "tlenek\defs.h"
#include "tlenek\utils.h"
#include "tlen_sdk\plugin_protocol_defs.h"


namespace tlenek {


class TLENEK_DLLIMPEXP ProtocolInfo : private ProtocolDef {

	private:

		void Init() {
			memset(&structSize, 0, sizeof(ProtocolDef));
		}


	public:

		ProtocolInfo() {
			Init();
		}

		ProtocolInfo(const char* id, const char* name, const char* ext = NULL, const char* desc = NULL);

		ProtocolInfo(const ProtocolInfo& ct);

		~ProtocolInfo() {
			delete [] ID;
			delete [] Name;
			delete [] Extension;
			delete [] Description;
		}


		const char* GetId() const {
			return ID;
		}
		
		void SetId(const char* id) {
			my_strdup(ID, id);
		}


		const char* GetName() {
			return Name;
		}
		
		void SetName(const char* name) {
			my_strdup(Name, name);
		}


		const char* GetExtension() {
			return Extension;
		}
		
		void SetExtension(const char* ext) {
			my_strdup(Extension, ext);
		}


		const char* GetDescription() {
			return Description;
		}
		
		void SetDescription(const char* desc) {
			my_strdup(Description, desc);
		}


//	friend class Protocol;

};


} // namespace tlenek


#endif // _TLENEK_PROTOCOL_INFO_H_
