/* ==========================================================================
 * Name:        tlenek\protocollist.h
 * Purpose:     Deklaracja klasy ProtocolList
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     11/10/2007 14:04:17
 * SVN-ID:      $Id: protocollist.h 15 2007-10-16 14:40:16Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#ifndef _TLENEK_PROTOCOL_LIST_H_
#define _TLENEK_PROTOCOL_LIST_H_

#include "tlenek\defs.h"
#include "tlenek\stringlist.h"
#include "tlen_sdk\plugin_protocol_defs.h"


namespace tlenek {


class TLENEK_DLLIMPEXP ProtocolList {

	private:

		StringList m_id;
		StringList m_name;

		ProtocolList() {}
		~ProtocolList() {}


	public:

		const char* GetId(int index) const;

		const char* GetName(int index) const;

		const char* GetName(const char* id) const;


		int Find(const char* id) {
			return m_id.Find(id);
		}


		bool Exists(const char* id) const {
			return m_id.Find(id) != -1;
		}


		int Size() const {
			return m_id.Size();
		}


		// aktualizuje liste, only_net okresla czy lista ma zawierac tylko
		// protokoly sieciowe, czyli bez SMS, GENERAL i ANON
		void Update(bool only_net = false);


		const char* operator[](int index) const {
			return GetId(index);
		}

		const char* operator[](const char* id) const {
			return GetName(id);
		}


	friend class Protocol;

};


} // namespace tlenek


#endif // _TLENEK_PROTOCOL_LIST_H_
