/* ==========================================================================
 * Name:        tlenek\tlen.h
 * Purpose:     Deklaracja klasy reprezentujacej komunikator udostepniajaca 
 *              dostep do poszczegolnych jego elementow (klas/obiektow)
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     01/10/2007 11:40:03
 * SVN-ID:      $Id: tlen.h 21 2007-11-14 23:28:50Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#ifndef _TLENEK_TLEN_H_
#define _TLENEK_TLEN_H_

#include "tlenek\defs.h"


namespace tlenek {


class ContactList;
class Hook;
class OptionsWindow;
class Function;
class Protocol;
class DialogHandle;


class TLENEK_DLLIMPEXP Tlen {

	private:

		static Tlen* instance;

		ContactList* m_cl;
		Hook* m_hook;
		OptionsWindow* m_ow;
		Function* m_func;
		Protocol* m_proto;
		DialogHandle* m_dh;

		Tlen();
		~Tlen();


	public:

		static Tlen* Get();

		static void Free();


		ContactList* GetContactList();

		Hook* GetHook();

		OptionsWindow* GetOptionsWindow();

		Function* GetFunction();

		Protocol* GetProtocol();

		DialogHandle* GetDialogHandle();

};


} // namespace tlenek


#endif // _TLENEK_TLEN_H_
