/* ==========================================================================
 * Name:        tlenek\utils.h
 * Purpose:     Deklaracje przydatnych funkcji, nie zwiazanych z tlenem
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     22/09/2007 14:24:16
 * SVN-ID:      $Id: utils.h 23 2007-11-19 22:05:03Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#ifndef _TLENEK_UTILS_H_
#define _TLENEK_UTILS_H_

#include <algorithm>
#include <string>
#include <ctype.h>
#include "tlenek\defs.h"


namespace tlenek {


// to samo co strdup z zwolnieniem wskaznika, do ktorego bedzie kopiowany string
// operuje na new i delete
TLENEK_DLLIMPEXP void my_strdup(char*& dest, const char* src, bool free = true);


TLENEK_DLLIMPEXP void my_cstrdup(char*& dest, const char* src, bool free = true);


TLENEK_DLLIMPEXP int my_strcmp(const char* s1, const char* s2);


TLENEK_DLLIMPEXP bool StrIsWhiteOnly(const char* str);



inline void strupper(std::string& str) {
	std::transform(str.begin(), str.end(), str.begin(), (int(*)(int)) toupper);
}


inline void strlower(std::string& str) {
	std::transform(str.begin(), str.end(), str.begin(), (int(*)(int)) tolower);
}


inline void strfupper(std::string& str) {
	std::transform(str.begin(), str.begin()+1, str.begin(), (int(*)(int)) toupper);
	std::transform(str.begin()+1, str.end(), str.begin()+1, (int(*)(int)) tolower);
}


} // namespace tlenek


#endif // _TLENEK_UTILS_H_
