/* ==========================================================================
 * Name:        contactinfo.cpp
 * Purpose:     Definicja klas ContactInfo i ContactInfoList
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     24/09/2007 14:30:44
 * SVN-ID:      $Id: contactinfo.cpp 12 2007-10-12 01:02:51Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\contactinfo.h"
#include "tlenek\tlen.h"
#include "tlenek\function.h"
#include "tlenek\exception.h"
#include "tlenek\misc.h"


namespace tlenek {


// ContactInfo

bool ContactInfo::proc = false;

ct_init_type ContactInfo::ct_init = NULL;
ct_free_type ContactInfo::ct_free = NULL;
ct_copy_type ContactInfo::ct_copy = NULL;


void ContactInfo::Init() {
	if (!proc) {
		ct_init = (ct_init_type) Tlen::Get()->GetFunction()->GetProcAddr(TPA_CT_INIT);
		ct_free = (ct_free_type) Tlen::Get()->GetFunction()->GetProcAddr(TPA_CT_FREE);
		ct_copy = (ct_copy_type) Tlen::Get()->GetFunction()->GetProcAddr(TPA_CT_COPY);
		proc = true;
	}
}



// ContactInfoList


bool ContactInfoList::proc = false;

cl_init_type ContactInfoList::cl_init = NULL;
cl_add_type  ContactInfoList::cl_add  = NULL;
cl_copy_type ContactInfoList::cl_copy = NULL;
cl_free_type ContactInfoList::cl_free = NULL;


void ContactInfoList::Init() {
	if (!proc) {
		cl_init = (cl_init_type) Tlen::Get()->GetFunction()->GetProcAddr(TPA_CL_INIT);
		cl_add  = (cl_add_type)  Tlen::Get()->GetFunction()->GetProcAddr(TPA_CL_ADD);
		cl_copy = (cl_copy_type) Tlen::Get()->GetFunction()->GetProcAddr(TPA_CL_COPY);
		cl_free = (cl_free_type) Tlen::Get()->GetFunction()->GetProcAddr(TPA_CL_FREE);
		proc = true;
	}
}


void ContactInfoList::Del(int index) {
	if (index >= 0 && index < count) {
		// usuwamy pozycje i przenosimy reszte, aby zalatac dziure ;p
		FreeContactDef(&contacts[index]);
		memmove(contacts + index, contacts + index + 1, sizeof(ContactsListDef)*(--count - index));
	} else {
		throw Exception(VALIDINDEX, NULL, "ContactInfoList::Del", __LINE__, __FILE__);
	}
}


ContactInfo* ContactInfoList::Get(int index) const {
	if (index >= 0 && index < count) {
		return (ContactInfo*) &contacts[index];
	} else {
		throw Exception(VALIDINDEX, NULL, "ContactInfoList::Get", __LINE__, __FILE__);
		return NULL;
	}
}


int ContactInfoList::Find(const char* contact, const char* protocol) const {
	for (int i=0; i<count; i++) {
		if (my_strcmp(contacts[i].ContactID, contact) == 0
			&& my_strcmp(contacts[i].ProtocolID, protocol) == 0) {
			return i;
		}
	}
	return -1;
}


} // namespace tlenek
