/* ==========================================================================
 * Name:        exception.cpp
 * Purpose:     Implementacja klasy Exception
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     01/10/2007 20:11:30
 * SVN-ID:      $Id: exception.cpp 1 2007-10-03 18:02:05Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include <windows.h>
#include <stdio.h>
#include "tlenek\exception.h"


namespace tlenek {


char* msg[10] = {
/* UNKNOWN */		"unknown exception",
/* VALIDINDEX */	"invalid index"
};


Exception::Exception(ExcCode code, const char* msg, const char* func, int line, const char* file) {
	m_code = code;
	my_strdup(m_msg, msg, false);
	my_strdup(m_func, func, false);
	m_line = line;
	my_strdup(m_file, file, false);
}


Exception::~Exception() {
	delete [] m_msg;
	delete [] m_func;
	delete [] m_file;
}


void Exception::show() {
	char buf[256];
	if (m_msg == NULL) m_msg = msg[m_code];
	_snprintf(buf, sizeof(buf), "Code: %d\nMsg: %s\nFrom: %s", m_code, m_msg, m_func);
	MessageBox(NULL, buf, "Exception", MB_OK | MB_ICONERROR | MB_TASKMODAL);
}


} // namespace tlenek
