/* ==========================================================================
 * Name:        function.cpp
 * Purpose:     Implementacja klasy Function
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     04/10/2007 19:08:42
 * SVN-ID:      $Id: function.cpp 16 2007-10-17 20:40:54Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\function.h"
#include "tlenek\misc.h"
#include "tlenek\exception.h"
#include "tlen_sdk\plugin_defs.h"
#include "tlen_sdk\plugin_struct.h"
#include "tlen_sdk\plugin_protocol_defs.h"
#include <list>
#include <iterator>


namespace tlenek {


int Function::Create(const char* name, TLENFUNCTION function) {

	HANDLE handle = GetTlenFunctions()->CreateTlenFunction(GetPluginInstance(), name, function);
	m_list.push_back(handle);
	return (int) handle;

}


void Function::Destroy(int id) {

	GetTlenFunctions()->DestroyTlenFunction(GetPluginInstance(), (HANDLE) id);
	m_list.remove((HANDLE) id);

}


void Function::DestroyAll() {

	for (en_list_t::iterator it = m_list.begin(); it != m_list.end(); ++it) {
		GetTlenFunctions()->DestroyTlenFunction(GetPluginInstance(), *it);
	}
	m_list.clear();

}


int Function::CallProto(const char* proto, const char* name, WPARAM wParam, LPARAM lParam) {
	ProtocolFunctionDef fn;
	InitializeStruct(fn);
	fn.ProtocolID = (char*) proto;
	fn.FunctionName = (char*) name;
	fn.wParam = wParam;
	fn.lParam = lParam;
	return Call(TLEN_PROTOCOL_CALL_FUNCTION, (WPARAM) &fn, NULL);
}


} // namespace tlenek
