/* ==========================================================================
 * Name:        handler.cpp
 * Purpose:     Implementacja klas EventHandler i EventHandlerTable
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     28/09/2007 13:49:48 (extracted from event.cpp)
 * SVN-ID:      $Id: handler.cpp 3 2007-10-04 21:38:16Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\handler.h"
#include <list>
#include <algorithm>


namespace tlenek {


HandlerTable* HandlerTable::instance = NULL;


HandlerTable* HandlerTable::GetInstance() {
	if (instance == NULL) {
		instance = new HandlerTable;
	}
	return instance;
}


void HandlerTable::Add(TLENFUNCTION function, Handler* instance) {
	en_t entry;
	entry.function = function;
	entry.instance = instance;
	m_list.push_back(entry);
}


void HandlerTable::Del(TLENFUNCTION function) {
	en_t entry;
	entry.function = function;
	entry.instance = 0;
	m_list.remove(entry);
}


Handler* HandlerTable::Get(TLENFUNCTION function) {
	en_t entry;
	entry.function = function;
	entry.instance = 0;

	en_list_t::iterator it;
	it = std::find(m_list.begin(), m_list.end(), entry);

	if (it == m_list.end()) return NULL;

	return it->instance;
}


} // namespace tlenek
