/* ==========================================================================
 * Name:        info.cpp
 * Purpose:     Implementacja funkcji zawartych przestrzeni nazw 'info'
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     30/09/2007 02:54:17 (extracted from misc.cpp)
 * SVN-ID:      $Id: info.cpp 4 2007-10-05 00:35:00Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\info.h"
#include "tlenek\tlen.h"
#include "tlenek\function.h"
#include "tlenek\misc.h"


namespace tlenek {
	namespace info {


	static ProfInfoDef* prof = NULL;
	static ProfileInfoDef* profEx = NULL;


	const char* GetTlenPath() {
		if (tlen_path == NULL) {
			int size = Tlen::Get()->GetFunction()->CallTS(TLEN_GET_EXE_PATH, NULL, NULL);
			tlen_path = new char[size];
			int ret = Tlen::Get()->GetFunction()->CallTS(TLEN_GET_EXE_PATH, (WPARAM) tlen_path, (LPARAM) size);
			if (ret != 0)
				FreeTlenPath();
		}
		return tlen_path;
	}


	ProfileInfo* GetProfileInfo() {
		if (prof == NULL) {
			TLENFUNCTION func = Tlen::Get()->GetFunction()->GetProcAddr(TPA_GET_PROF_INFO);
			if (func) {
				prof = (ProfInfoDef*) func(NULL, NULL);
			}
		}
		return prof;
	}


	ProfileInfoEx* GetProfileInfoEx() {
		if (profEx == NULL) {
			TLENFUNCTION func = Tlen::Get()->GetFunction()->GetProcAddr(TPA_GET_PROFILE_INFO);
			if (func) {
				profEx = (ProfileInfoDef*) func(NULL, NULL);
			}
		}
		return profEx;
	}


	} // namespace info
} // namespace tlenek
