/* ==========================================================================
 * Name:        misc.cpp
 * Purpose:     Implementacje funkcji deklarowanych w naglowku tlenek\misc.h
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     20/09/2007 16:38:51
 * SVN-ID:      $Id: misc.cpp 10 2007-10-10 19:03:31Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\misc.h"
#include "tlenek\tlen.h"
#include "tlenek\function.h"
#include "tlen_sdk\plugin_procaddr.h"


namespace tlenek {


	static TLENFUNCTION sha1 = NULL;
	static TLENFUNCTION hash = NULL;

	const char* SHA1(const char* string) {
		if (sha1 == NULL) {
			sha1 = Tlen::Get()->GetFunction()->GetProcAddr(TPA_SHA1);
		}
		return (char*) sha1((WPARAM) string, (LPARAM) strlen(string));
	}


	const char* HASH(const char* string) {
		if (hash == NULL) {
			hash = Tlen::Get()->GetFunction()->GetProcAddr(TPA_MYHASH);
		}
		return (char*) hash((WPARAM) string, NULL);
	}


} // namespace tlenek
