/* ==========================================================================
 * Name:        optionswindow.cpp
 * Purpose:     Implementacje klas OptionPage i OptionsWindow
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     28/09/2007 23:40:57
 * SVN-ID:      $Id: optionswindow.cpp 20 2007-11-08 15:38:29Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\optionswindow.h"


namespace tlenek {


const long DEFAULT_OPTIONPAGESTYLE = STYLE_TLENCOLOR | STYLE_ICONTRANS;


void OptionPage::Init() {
	memset(&structSize, 0, sizeof(TlenOptionPageDefinition));
	structSize = sizeof(TlenOptionPageDefinition);
	OwnerData = this;	// uzywane przez nas, wiec nie ma Get/SetClientData
	m_title = NULL;
	m_desc = NULL;
	m_bgcolor = 0;
	m_hwnd = NULL;
}


OptionPage::OptionPage(const char* id, const char* name, long style) {
	Init();
	SetId(id);
	SetName(name);
	SetStyle(style);
}

OptionPage::~OptionPage() {
	free(ID);
	free(ParentID);
	free(Caption);
	free(m_title);
	free(m_desc);
}


} // namespace tlenek
