/* ==========================================================================
 * Name:        plugin.cpp
 * Purpose:     Implementacje klasy Plugin
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     20/09/2007 15:52:17
 * SVN-ID:      $Id: plugin.cpp 23 2007-11-19 22:05:03Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\plugin.h"
#include "tlenek\handler.h"
#include "tlenek\tlen.h"
#include "tlenek\info.h"
#include "tlenek\xml.h"
#include "tlenek\xml2.h"


namespace tlenek {


Plugin* Plugin::instance = NULL;


Plugin::Plugin() {
	Plugin::instance = this;
	m_hInst = NULL;
	m_tlen_func = NULL;
	InitializeStruct(m_plug_info);
	m_plug_info.PluginAPIVersion = PLUGIN_API_VERSION;
	m_tlen_ver = 0;
}


Plugin::~Plugin() {
	HandlerTable::FreeInstance();
	Tlen::Free();
	info::FreeTlenPath();
	xml::Deinit();
	xml2::Deinit();
}


} // namespace tlenek
