/* ==========================================================================
 * Name:        protocol.cpp
 * Purpose:     Implementacja klasy Protocol
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     08/10/2007 20:56:46
 * SVN-ID:      $Id: protocol.cpp 8 2007-10-08 20:18:38Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\protocol.h"
#include "tlenek\protocolinfo.h"
#include "tlenek\tlen.h"
#include "tlenek\function.h"
#include "tlen_sdk\plugin_protocol_defs.h"
#include <list>


namespace tlenek {


void Protocol::Add(const ProtocolInfo& proto) {
	en_t entry;
	entry.proto = (char*) proto.GetId();
	m_list.push_back(entry);

	Tlen::Get()->GetFunction()->CallTS(TLEN_PROTOCOL_ADDNEWPROTOCOL, (WPARAM) &proto, NULL);
}


void Protocol::Add(const char* id, const char* name, const char* ext, const char* desc) {
	en_t entry;
	entry.proto = (char*) id;
	m_list.push_back(entry);

	ProtocolDef pd;
	InitializeStruct(pd);
	pd.ID = (char*) id;
	pd.Name = (char*) name;
	pd.Extension = (char*) ext;
	pd.Description = (char*) desc;

	Tlen::Get()->GetFunction()->CallTS(TLEN_PROTOCOL_ADDNEWPROTOCOL, (WPARAM) &pd, NULL);
}


void Protocol::Del(const char* id) {
	en_t entry;
	entry.proto = (char*) id;;
	m_list.remove(entry);

	Tlen::Get()->GetFunction()->CallTS(TLEN_PROTOCOL_REMOVEPROTOCOL, (WPARAM) id, NULL);
}



void Protocol::DelAll() {

	for (en_list_t::iterator it = m_list.begin(); it != m_list.end(); ++it) {
		Del(it->proto);
	}

	m_list.clear();

}


} // namespace tlenek
