/* ==========================================================================
 * Name:        protocolinfo.cpp
 * Purpose:     Definicja klasy ProtocolInfo
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     08/10/2007 20:25:29
 * SVN-ID:      $Id: protocolinfo.cpp 8 2007-10-08 20:18:38Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\protocolinfo.h"
#include "tlenek\utils.h"


namespace tlenek {


ProtocolInfo::ProtocolInfo(const char* id, const char* name, const char* ext, const char* desc) {
	Init();
	SetId(id);
	SetName(name);
	SetExtension(desc);
	SetDescription(desc);
}


ProtocolInfo::ProtocolInfo(const ProtocolInfo& pi) {

	ProtocolDef* def = (ProtocolDef*) &pi;

	structSize = def->structSize;
	my_strdup(def->ID, ID);
	my_strdup(def->Name, Name);
	my_strdup(def->Extension, Extension);
	my_strdup(def->Description, Description);
	CapsFlag1 = def->CapsFlag1;
	CapsFlag2 = def->CapsFlag2;
	CapsFlag3 = def->CapsFlag3;
	CapsFlag4 = def->CapsFlag4;

}


} // namespace tlenek
