/* ==========================================================================
 * Name:        protocollist.cpp
 * Purpose:     Implementacja klasy ProtocolList
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     11/10/2007 14:05:36
 * SVN-ID:      $Id: protocollist.cpp 15 2007-10-16 14:40:16Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\protocollist.h"
#include "tlenek\tlen.h"
#include "tlenek\function.h"
#include "tlenek\exception.h"


namespace tlenek {


const char* ProtocolList::GetId(int index) const {
	try {
		return m_id.Get(index);

	} catch (const Exception& e) {
		if (e.GetCode() == VALIDINDEX) {
			throw Exception(VALIDINDEX, NULL, "ProtocolList::GetId", __LINE__, __FILE__);
		} else {
			throw e;
		}
	}
}


const char* ProtocolList::GetName(int index) const {
	try {
		return m_name.Get(index);

	} catch (const Exception& e) {
		if (e.GetCode() == VALIDINDEX) {
			throw Exception(VALIDINDEX, NULL, "ProtocolList::GetName", __LINE__, __FILE__);
		} else {
			throw e;
		}
	}
}


const char* ProtocolList::GetName(const char* id) const {

	int idx = m_id.Find(id);

	if (idx != -1) {
		return m_name.Get(idx);
	} else {
		return NULL;
	}

}


void ProtocolList::Update(bool only_net) {

	Tlen::Get()->GetFunction()->CallTS(TLEN_PROTOCOL_GETPROTOCOLLIST, (WPARAM) &m_id, (LPARAM) &m_name);

	if (only_net) {

		int idx = m_id.Find(PROTOCOL_ID_SMS);
		if (idx != -1) {
			m_id.Del(idx);
			m_name.Del(idx);
		}

		idx = m_id.Find(PROTOCOL_ID_GENERAL);
		if (idx != -1) {
			m_id.Del(idx);
			m_name.Del(idx);
		}


		idx = m_id.Find(PROTOCOL_ID_CHATANONYMOUS);
		if (idx != -1) {
			m_id.Del(idx);
			m_name.Del(idx);
		}
	}
}


} // namespace tlenek
