/* ==========================================================================
 * Name:        tlen.cpp
 * Purpose:     Implementacja klasy Tlen
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     01/10/2007 11:41:17
 * SVN-ID:      $Id: tlen.cpp 21 2007-11-14 23:28:50Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\tlen.h"
#include "tlenek\contactlist.h"
#include "tlenek\hook.h"
#include "tlenek\optionswindow.h"
#include "tlenek\function.h"
#include "tlenek\protocol.h"
#include "tlenek\dialoghandle.h"


namespace tlenek {


Tlen* Tlen::instance = NULL;


Tlen::Tlen() {
	m_cl = NULL;
	m_hook = NULL;
	m_ow = NULL;
	m_func = NULL;
	m_proto = NULL;
	m_dh = NULL;
}


Tlen::~Tlen() {
	delete m_cl;
	delete m_hook;
	delete m_ow;
	delete m_func;
	delete m_proto;
	delete m_dh;
}


Tlen* Tlen::Get() {
	if (instance == NULL) {
		instance = new Tlen;
	}
	return instance;
}


void Tlen::Free() {
	delete instance;
	instance = NULL;
}


ContactList* Tlen::GetContactList() {
	if (m_cl == NULL) {
		m_cl = new ContactList;
	}
	return m_cl;
}


Hook* Tlen::GetHook() {
	if (m_hook == NULL) {
		m_hook = new Hook;
	}
	return m_hook;
}


OptionsWindow* Tlen::GetOptionsWindow() {
	if (m_ow == NULL) {
		m_ow = new OptionsWindow;
	}
	return m_ow;
}


Function* Tlen::GetFunction() {
	if (m_func == NULL) {
		m_func = new Function;
	}
	return m_func;
}


Protocol* Tlen::GetProtocol() {
	if (m_proto == NULL) {
		m_proto = new Protocol;
	}
	return m_proto;
}


DialogHandle* Tlen::GetDialogHandle() {
	if (m_dh == NULL) {
		m_dh = new DialogHandle;
	}
	return m_dh;
}


} // namespace tlenek
