/* ==========================================================================
 * Name:        utils.cpp
 * Purpose:     Implementacje funkcji deklarowanych w naglowku tlenek\utils.h
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     22/09/2007 14:24:16
 * SVN-ID:      $Id: utils.cpp 23 2007-11-19 22:05:03Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include <stdlib.h>
#include <string.h>
#include "tlenek\utils.h"


namespace tlenek {


void my_strdup(char*& dest, const char* src, bool free) {
	if (free) delete [] dest;
	if (!src) {
		dest = NULL;
	} else {
		dest = new char[strlen(src)+1];
		strcpy(dest, src);
	}
} 

void my_cstrdup(char*& dest, const char* src, bool free) {
	if (free) ::free(dest);
	if (!src) {
		dest = NULL;
	} else {
		dest = (char*) malloc(strlen(src)+1);
		strcpy(dest, src);
	}
}

int my_strcmp(const char* s1, const char* s2) {
	if (!s1 || !s2) {
		if (s1) {
			return 1;
		} else if (s2) {
			return -1;
		} else {
			return 0;
		}
	} else {
		return strcmp(s1, s2);
	}
}


bool StrIsWhiteOnly(const char* str) {
	char c;
	while (c = *str++) {
		if (c != ' ' && c != '\t' && c != '\n' && c != '\r')
			return false;
	}
	return true;
}


} // namespace tlenek
