/* ==========================================================================
 * Name:        xml2.cpp
 * Purpose:     Implementacja klas parsera XML wykorzystujacego libexpat2.dll
 * Author:      Marcin 'malcom' Malich <me@malcom.pl>
 * Modified by:
 * Created:     14/11/2007  12:31:19
 * SVN-ID:      $Id: xml2.cpp 24 2007-11-20 14:23:04Z malcom $
 * Copyright:   (c) 2007 Marcin 'malcom' Malich <me@malcom.pl>, Poland
 * Licence:     GNU Lesser General Public License
 * ========================================================================== */

#include "tlenek\xml2.h"
#include <string.h>


namespace tlenek {
namespace xml2 {


xmlnode2file_t xmlnode2file;
xmlnode2str_t xmlnode2str;
xmlnode_file_t xmlnode_file;
xmlnode_free_t xmlnode_free;
xmlnode_get_attrib_t xmlnode_get_attrib;
xmlnode_get_data_t xmlnode_get_data;
xmlnode_get_tag_t xmlnode_get_tag;
xmlnode_get_tag_data_t xmlnode_get_tag_data;
xmlnode_str_t xmlnode_str;


void Init(const char* dir) {
	char* path = new char[strlen(dir)+14];
	strcpy(path, dir);
	strcat(path, "libexpat2.dll");


	hModule = LoadLibrary(path);
	if (hModule == NULL) {
		// wyjatek
	}

	delete [] path;

	// pobieramy adresy funkcji

	xmlnode2file = (xmlnode2file_t) GetProcAddress(hModule, "xmlnode2file");
	if (xmlnode2file == NULL) {
		// wyjatek
	}

	xmlnode2str = (xmlnode2str_t) GetProcAddress(hModule, "xmlnode2str");
	if (xmlnode2str == NULL) {
		// wyjatek
	}

	xmlnode_file = (xmlnode_file_t) GetProcAddress(hModule, "xmlnode_file");
	if (xmlnode_file == NULL) {
		// wyjatek
	}

	xmlnode_free = (xmlnode_free_t) GetProcAddress(hModule, "xmlnode_free");
	if (xmlnode_free == NULL) {
		// wyjatek
	}

	xmlnode_get_attrib = (xmlnode_get_attrib_t) GetProcAddress(hModule, "xmlnode_get_attrib");
	if (xmlnode_get_attrib == NULL) {
		// wyjatek
	}

	xmlnode_get_data = (xmlnode_get_data_t) GetProcAddress(hModule, "xmlnode_get_data");
	if (xmlnode_get_data == NULL) {
		// wyjatek
	}

	xmlnode_str = (xmlnode_str_t) GetProcAddress(hModule, "xmlnode_str");
	if (xmlnode_str == NULL) {
		// wyjatek
	}
}


bool Document::ToString(char* buf, size_t* len) {
	if (len == NULL)
		return false;
	char* str = xmlnode2str(m_root);
	if (str == NULL)
		return false;
	size_t slen = strlen(str);
	if (buf == NULL || slen > *len) {
		*len = slen;
		return false;
	}
	strncpy(buf, str, slen);
	*len = slen;
	return true;
}


} // namespace xml2
} // namespace tlenek
